//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit_Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Main *Form_Main;
//---------------------------------------------------------------------------
__fastcall TForm_Main::TForm_Main(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::FormShow(TObject *Sender)
{
	try
	{
		m_ptUtil = new TPrjUtil();
	}
	catch(std::bad_alloc)
	{
		// Critical fault
		Application->MessageBox(L"Memory Allocation Fault", L"Error", MB_OK);
		this->Close();
	}
	m_ptUtil->SetDlgOwner(Form_Main);
	try
	{
		this->m_ptMMTimerMain = new TMultiMediaTimer();
	}
	catch(std::bad_alloc)
	{
		// Critical fault
		m_ptUtil->ShowMessageDlg(L"Memory Allocation Fault", mtWarning, (TMsgDlgButtons() << mbOK));
		return;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::FormClose(TObject *Sender, TCloseAction &Action)
{
	if( this->m_ptMMTimerMain != NULL ) delete this->m_ptMMTimerMain;
	if( this->m_ptUtil != NULL ) delete this->m_ptUtil;
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::Button_StartClick(TObject *Sender)
{
// Start

	this->m_rl64StartTime = Now().Val;
	for( int i = 0; i < MAX_SERIES_COUNT;  i++ )
	{
		this->m_arl64Value[i] = (double)i * 100.0;
	}
	this->m_uint32Count = 0;
	this->Chart_Main->BottomAxis->Automatic = false;
	for(int m = 0; m < this->Chart_Main->SeriesCount(); m++ )
	{
		this->Chart_Main->Series[m]->Clear();
		this->Chart_Main->Series[m]->OnAfterAdd = this->SeriesAfterAdd;
	}
	this->m_ptMMTimerMain->StartTimer(2, this->CyclicEvent);
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::Button_StopClick(TObject *Sender)
{
// Stop
	this->m_ptMMTimerMain->StopTimer();
	this->Chart_Main->BottomAxis->SetMinMax(this->Chart_Main->Series[0]->XValues->MinValue, this->Chart_Main->Series[0]->XValues->MaxValue);
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::Button_CloseClick(TObject *Sender)
{
// Close
	this->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::CyclicEvent(void)
{
// Cyclic event
	double rl64Value;
	double rl64Time = (Now().Val - this->m_rl64StartTime) * 86400.0;
	this->m_uint32Count++;
	if( this->m_uint32Count == 500 )
	{
		this->m_uint32Count = 0;
	}
	for( int i = 0; i < MAX_SERIES_COUNT;  i++ )
	{
		if( this->m_uint32Count < 250 )
		{
			this->m_arl64Value[i] += 1.0;
		}
		else
		{
			this->m_arl64Value[i] -= 1.0;
		}
		this->Chart_Main->Series[i]->AddXY(rl64Time, this->m_arl64Value[i], "", this->Chart_Main->Series[i]->SeriesColor);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm_Main::SeriesAfterAdd(TChartSeries *Sender, int ValueIndex)
{
	double rlVal = Sender->XValues->MaxValue;
	Sender->GetHorizAxis->SetMinMax(rlVal - 10.0, rlVal);
}
//---------------------------------------------------------------------------
