//---------------------------------------------------------------------------

#ifndef Unit_MainH
#define Unit_MainH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>

#include "ProjectUtility.hpp"
#include "MultiMediaTimer.hpp"
#include <Vcl.ExtCtrls.hpp>
#include <VCLTee.Chart.hpp>
#include <VCLTee.Series.hpp>
#include <VCLTee.TeEngine.hpp>
#include <VCLTee.TeeProcs.hpp>

#define MAX_SERIES_COUNT 4
//---------------------------------------------------------------------------
class TForm_Main : public TForm
{
__published:
	TChart *Chart_Main;
	TPanel *Panel_Main;
	TFastLineSeries *Series1;
	TFastLineSeries *Series2;
	TFastLineSeries *Series3;
	TFastLineSeries *Series4;
	TButton *Button_Start;
	TButton *Button_Stop;
	TButton *Button_Close;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall Button_StartClick(TObject *Sender);
	void __fastcall Button_StopClick(TObject *Sender);
	void __fastcall Button_CloseClick(TObject *Sender);
private:
	TPrjUtil *m_ptUtil;
	TMultiMediaTimer *m_ptMMTimerMain;
public:
	unsigned long m_uint32Count;
	double m_rl64StartTime;
	double m_arl64Value[MAX_SERIES_COUNT];
	void __fastcall CyclicEvent(void);
	void __fastcall SeriesAfterAdd(TChartSeries *Sender, int ValueIndex);
	__fastcall TForm_Main(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm_Main *Form_Main;
//---------------------------------------------------------------------------
#endif
